Linux安装ImageMagick处理webp格式图片

一、ubuntu环境(php用Ubuntu内置版本):

1、安装php扩展

sudo apt install php7.1-imagick

2、安装webp

sudo apt install webp

重启php-fpm服务器

二、centos7(php编译安装版本)

下面是安装步骤,要细心。文档:http://www.imagemagick.org/script/install-source.php

1、安装imagemagick( 重点: --with-webp特别重要哦~~~

下载安装包

wget https://www.imagemagick.org/download/ImageMagick.tar.gz
tar -zxvf ImageMagick.tar.gz
cd ImageMagick-7.0.8-27

./configure --with-webp

make && make install

查看ImageMagick支持的格式,确认包含 webp

convert -list format

测试将webp格式转换为jpg格式,

convert test.webp test.jpg

2、安装php扩展

下载安装包

wget http://pecl.php.net/get/imagick-3.4.3.tgz

编译安装

tar xvf imagick-3.4.3.tgz
cd imagick-3.4.3

phpize

./configure

make && make install

在php.ini添加扩展,如:

extension="/usr/lib64/php/modules/imagick.so"

重启php-fpm服务器

在终端查看php -m| grep imagick是否添加扩展成功

3、安装libwebp

yum -y install libwebp-devel libwebp-tools

三、php转换代码片段

/**
* @param1 $webp webp格式图片
* @param2 转换的格式,如jpg,png等等
*/

public function webpToPic($webp,$type)
{
    $IM= new imagick($webp);
    $IM->setImageFormat($type);
    $fileName= '/tmp/magick-test.'.$type;
    $IM->writeImage($fileName);
}

更多imagick用法请看 http://php.net/imagick

四、常见错误

1、错误代码如下:

no decode delegate for this image format `/tmp/magick-7ukghfw7' @error/constitute.c/readimage/532

问题:centos6.5自带的imagemagick版本是6.7的,版本过低,不能解码wepb格式的文件,由于imagick的编译安装依赖imagemagick,所以也不能decode webp

解决办法:如安装自带的版本,请先卸载,再安装imagemagick大于6.7的版本,重新编译imagick扩展,当前官方版本为7.0

php --ri imagick查看编译信息

imagick module => enabled
imagick moduleversion=> 3.4.3
imagick classes => Imagick, ImagickDraw, ImagickPixel, ImagickPixelIterator, ImagickKernel
Imagick compiled with ImageMagickversion=> ImageMagick 6.8.9-9 Q16 x86_64 2017-07-31 http://www.imagemagick.org
Imagick using ImageMagick libraryversion=> ImageMagick 6.8.9-9 Q16 x86_64 2017-07-31 http://www.imagemagick.org

这是ubuntu 16.04自带的ImageMagick版本,大于6.7,我本地安装的imagick扩展是可以正常解码

2、错误代码如下:

delegate failed`"dwebp" -pam "%i" -o "%o"'@error/delegate.c/InvokeDelegate/1310.

问题:没有安装webp支持

解决方法:

// ubuntu

sudo apt install webp

// centos

sudo yum -y install libwebp-devel libwebp-tools

3、错误代码如下

insufficient image datainfile`/tmp/magick-14354ebkvniy2usaq' @error/webp.c/readwebpimage/275

问题:文件中图像数据不足

解决办法:先卸载libwebp,然后重新编译ImageMagick,最后再安装libwebp,libwebp-tools,重启php服务。

推荐阅读更多精彩内容